SystemOrganization addCategory: #FixUnderscores!

!MethodReference methodsFor: '*fixUnderscores' stamp: 'cmm 5/1/2006 19:38'!
fixUnderscores
	"Replace underscores with :=. Answer true if fixed or no fix necessary, false if manual fix required"

	| src cm ts |
	"Check if we do need to do anything"
	src := self actualClass sourceCodeAt: methodSymbol.
	(src includes: $_) ifFalse: [^true].

	"Chicken out if there is a literal underscore"
	cm := self actualClass compiledMethodAt: methodSymbol.
	(cm hasLiteralSuchThat: [:lit | 
		lit = $_ or: [lit isString and: [lit includes: $_]]]) ifTrue: [^false].

	"Otherwise, replace underscores with :="
	src := src copyReplaceAll: '_' with: ':='.
	ts := self timeStamp.
	ts = '' ifTrue: [ts := nil].
	self actualClass 
		compile: src
		classified: ClassOrganizer default
		withStamp: ts 
		notifying: nil.

	^true
! !

Object subclass: #FixUnderscores
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FixUnderscores'!

!FixUnderscores class methodsFor: 'fixing' stamp: 'bf 4/7/2006 14:47'!
arrowChar
	"FIXME: this should rather be (Character leftArrow)"
	^Character value: 16r8F! !

!FixUnderscores class methodsFor: 'fixing' stamp: 'bf 10/18/2005 19:05'!
fixFont: aFont
	| glyph underline |
	glyph := aFont characterFormAt: $_.
	"save arrow glyph to arrowChar codepoint"
	((glyph copy: (0@aFont ascent corner: glyph extent)) isAllWhite
		and: [(aFont characterFormAt: self arrowChar) isAllWhite])
			ifTrue: [aFont characterFormAt: self arrowChar put: glyph].
	"make underscore glyph"
	glyph fillWhite.
	underline := aFont ascent + 1.
	glyph fillBlack: (1@underline extent: glyph width-1@1).
	aFont characterFormAt: $_ put: glyph.! !

!FixUnderscores class methodsFor: 'fixing' stamp: 'bf 11/26/2004 21:52'!
fixFonts
	"self fixFonts"

	StrikeFont allInstances
		do: [:fnt | self fixFont: fnt]
		displayingProgress: 'Fixing Bitmap Fonts'.! !

!FixUnderscores class methodsFor: 'fixing' stamp: 'bf 4/7/2006 15:11'!
fixPackage: aPackageName
	^self fixPackages: {aPackageName}

! !

!FixUnderscores class methodsFor: 'fixing' stamp: 'bf 4/7/2006 15:23'!
fixPackages: packageNames
	"FixUnderscores fixPackages: #('FixUnderscores' 'Bert')"

	| failed |
	failed := OrderedCollection new.

	packageNames
		do: [:pkgName | (PackageInfo named: pkgName) methods
			do: [:mRef | mRef fixUnderscores ifFalse: [failed add: mRef]] 
			displayingProgress: pkgName]
		displayingProgress: 'Fixing ...'.

	failed isEmpty ifFalse: [
		MessageSet openMessageList: failed
			name: 'These methods with literal underscores were not fixed'
			autoSelect: '_'].! !

!FixUnderscores class methodsFor: 'class initialization' stamp: 'bf 10/18/2005 12:13'!
initialize
	"self initialize"

	self fixFonts.
	self inform: 'Fonts were _fixed_.\The arrow glyph is now Character value ' withCRs,
		self arrowChar asInteger hex, ' ($', self arrowChar asString, ')'.
! !
FixUnderscores initialize!
